# unreal-shimloader

### Warning: This is currently experimental and problems WILL happen. Save often, yada yada.
This is a shim for the RE-UE4SS modloader, enabling Thunderstore Mod Manager and r2modmanPlus support.

### Not using Thunderstore Mod Manager or r2modmanPlus?
If you are not using either of the previous mod managers then you can opt for a manual installation. unreal-shimloader
will load the UE4SS binary for you.

**Manual installation**:

Note: `GAME` in the following text refers to the top-level directory within the game's folder. This could be "Pal", for *Palworld*, or "VotV", 
for *Voices of the Void*.

1. Copy `dwmapi.dll` into the `GAME/Binaries/Win64` directory. Its new path should be `GAME/Binaries/Win64/dwmapi.dll`.
2. Copy the contents of the `UE4SS` folder in the package into `GAME/Binaries/Win64`.

`GAME/Binaries/Win64` should now contain the following *new* files and folders:
- `GAME-Win64-Shipping.exe`
- `ue4ss.dll`
- `UE4SS-settings.ini`
- `dwmapi.dll` ← *This is the unreal-shimloader binary. It will load UE4SS for you.*
- `Mods/`

### Mods and Configs

unreal-shimloader is controlled via the following arguments:

`--mod-dir`: The path of a directory which contains one or more directories, of which contain ue4ss lua and dll mods.
- Maps to `GAME/Binaries/Win64/Mods`

`--pak-dir`: The path of a directory which contains one or more blueprint mods (`.pak` files).
- Maps to `GAME/Content/Paks/LogicMods`

`--cfg-dir`: The path of a directory which contains config files, usually with the `.cfg` extension.
- Maps to `GAME/Config`
